// This code was generated by a tool.
// Processing tool available at https://github.com/mezoni/peg

import 'package:peg/grammar/expressions.dart';
import 'package:peg/grammar/grammar.dart';
import 'package:peg/grammar/production_rule.dart';

int _escape(int c) {
  switch (c) {
    case 110:
      return 10;      
    case 114:
      return 13;      
    case 116:
      return 9;      
  }    
  return c;
}

Expression _prefix(dynamic prefix, Expression expression, String action) {  
  switch (prefix) {
    case '&':
     expression = new AndPredicateExpression(expression);
     break;
    case '!':
     expression = new NotPredicateExpression(expression);
     break;        
  }
  expression.action = action;
  return expression;
}

Expression _suffix(String suffix, Expression expression) {
  switch (suffix) {
    case '?':
      return new OptionalExpression(expression);
    case '*':
      return  new ZeroOrMoreExpression(expression);
    case '+':
      return new OneOrMoreExpression(expression);        
  }
  return expression;
}

class PegParser {
  static final List<String> _ascii = new List<String>.generate(128, (c) => new String.fromCharCode(c));
  
  static final List<String> _expect0 = <String>["IDENTIFIER"];
  
  static final List<String> _expect1 = <String>["\'(\'", "\'.\'", "\'[\'", "IDENTIFIER", "LITERAL"];
  
  static final List<String> _expect10 = <String>["\'.\'"];
  
  static final List<String> _expect11 = <String>["EOF"];
  
  static final List<String> _expect12 = <String>["\'%{\'"];
  
  static final List<String> _expect13 = <String>["\'<-\'"];
  
  static final List<String> _expect14 = <String>["LITERAL"];
  
  static final List<String> _expect15 = <String>["CHAR"];
  
  static final List<String> _expect16 = <String>["\'!\'"];
  
  static final List<String> _expect17 = <String>["\'(\'"];
  
  static final List<String> _expect18 = <String>["\'+\'"];
  
  static final List<String> _expect19 = <String>["\'?\'"];
  
  static final List<String> _expect2 = <String>["\'/\'"];
  
  static final List<String> _expect20 = <String>["SPACING"];
  
  static final List<String> _expect21 = <String>["\'#\'", "SPACE"];
  
  static final List<String> _expect22 = <String>["\'*\'"];
  
  static final List<String> _expect23 = <String>["ACTION_BODY"];
  
  static final List<String> _expect24 = <String>["\'#\'"];
  
  static final List<String> _expect25 = <String>[null];
  
  static final List<String> _expect26 = <String>["EOL"];
  
  static final List<String> _expect27 = <String>["GLOBALS_BODY"];
  
  static final List<String> _expect28 = <String>["HEX_NUMBER"];
  
  static final List<String> _expect29 = <String>["IDENT_CONT"];
  
  static final List<String> _expect3 = <String>["\'!\'", "\'&\'"];
  
  static final List<String> _expect30 = <String>["IDENT_START"];
  
  static final List<String> _expect31 = <String>["SPACE"];
  
  static final List<String> _expect4 = <String>["\'*\'", "\'+\'", "\'?\'"];
  
  static final List<String> _expect5 = <String>["\'{\'"];
  
  static final List<String> _expect6 = <String>["\'&\'"];
  
  static final List<String> _expect7 = <String>["\'[\'"];
  
  static final List<String> _expect8 = <String>["RANGE"];
  
  static final List<String> _expect9 = <String>["\')\'"];
  
  static final List<bool> _lookahead = _unmap([0x20e3, 0xffffffe, 0x1ffffffd, 0x7000020c, 0x68ffffff, 0x7fffffff, 0x7ffffc07, 0x7ffffa1f, 0x200004ff]);
  
  static final List<bool> _mapping0 = _unmap([0x821, 0x1c000000, 0x144000]);
  
  static final List<bool> _mapping1 = _unmap([0x9]);
  
  static final List<bool> _mapping2 = _unmap([0x7e03ff, 0xfc0000]);
  
  static final List<bool> _mapping3 = _unmap([0x43ffffff, 0x7fffffe]);
  
  static final List<bool> _mapping4 = _unmap([0x800001]);
  
  static final List<int> _strings0 = <int>[37, 123];
  
  static final List<int> _strings1 = <int>[125, 37];
  
  static final List<int> _strings2 = <int>[60, 45];
  
  static final List<int> _strings3 = <int>[13, 10];
  
  final List<int> _tokenFlags = [1, 1, 1, 1, 0, 0, 1, 0, 0, 1, 0];
  
  final List<String> _tokenNames = ["SPACING", "ACTION_BODY", "CHAR", "\'#\'", "EOL", "GLOBALS_BODY", "HEX_NUMBER", "IDENT_CONT", "IDENT_START", "RANGE", "SPACE"];
  
  static final List<List<int>> _transitions0 = [[65, 90, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions1 = [[33, 34, 38, 40, 46, 46, 65, 91, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions10 = [[10, 10], [13, 13]];
  
  static final List<List<int>> _transitions11 = [[48, 57], [65, 90, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions12 = [[9, 9, 32, 32], [10, 10, 13, 13]];
  
  static final List<List<int>> _transitions2 = [[33, 33], [38, 38]];
  
  static final List<List<int>> _transitions3 = [[34, 34, 39, 40, 46, 46, 65, 91, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions4 = [[42, 42], [43, 43], [63, 63]];
  
  static final List<List<int>> _transitions5 = [[34, 34, 39, 39], [40, 40], [46, 46], [65, 90, 95, 95, 97, 122], [91, 91]];
  
  static final List<List<int>> _transitions6 = [[34, 34], [39, 39]];
  
  static final List<List<int>> _transitions7 = [[9, 10, 13, 13, 32, 32], [35, 35]];
  
  static final List<List<int>> _transitions8 = [[0, 122, 124, 1114111], [123, 123]];
  
  static final List<List<int>> _transitions9 = [[0, 91, 93, 1114111], [92, 92]];
  
  List _cache;
  
  int _cachePos;
  
  List<int> _cacheRule;
  
  List<int> _cacheState;
  
  int _ch;
  
  int _cursor;
  
  List<PegParserError> _errors;
  
  List<String> _expected;
  
  int _failurePos;
  
  List<int> _input;
  
  int _inputLen;
  
  int _startPos;
  
  int _testing;
  
  int _token;
  
  int _tokenLevel;
  
  int _tokenStart;
  
  bool success;
  
  final String text;
  
  PegParser(this.text) {
    if (text == null) {
      throw new ArgumentError('text: $text');
    }    
    _input = _toCodePoints(text);
    _inputLen = _input.length;
    if (_inputLen >= 0x3fffffe8 / 32) {
      throw new StateError('File size to big: $_inputLen');
    }  
    reset(0);    
  }
  
  void _beginToken(int tokenId) {
    if (_tokenLevel++ == 0) {
      _token = tokenId;
      _tokenStart = _cursor;
    }  
  }
  
  void _endToken() {
    if (--_tokenLevel == 0) {
      _token = null;
      _tokenStart = null;
    }    
  }
  
  void _failure([List<String> expected]) {  
    if (_failurePos > _cursor) {
      return;
    }
    if (_failurePos < _cursor) {    
      _expected = [];
     _failurePos = _cursor;
    }
    if (_token != null) {
      var flag = _tokenFlags[_token];
      var name = _tokenNames[_token];
      if (_failurePos == _inputLen && (flag & 1) != 0) {             
        var message = "Unterminated $name";
        _errors.add(new PegParserError(PegParserError.UNTERMINATED, _failurePos, _tokenStart, message));            
      }
      else if (_failurePos > _tokenStart && (flag & 1) != 0) {             
        var message = "Malformed $name";
        _errors.add(new PegParserError(PegParserError.MALFORMED, _failurePos, _tokenStart, message));            
      }
      _expected.add(name);        
    } else if (expected == null) {
      _expected.add(null);
    } else {
      _expected.addAll(expected);
    }   
  }
  
  List _flatten(dynamic value) {
    if (value is List) {
      var result = [];
      var length = value.length;
      for (var i = 0; i < length; i++) {
        var element = value[i];
        if (element is Iterable) {
          result.addAll(_flatten(element));
        } else {
          result.add(element);
        }
      }
      return result;
    } else if (value is Iterable) {
      var result = [];
      for (var element in value) {
        if (element is! List) {
          result.add(element);
        } else {
          result.addAll(_flatten(element));
        }
      }
    }
    return [value];
  }
  
  int _getState(List<List<int>> transitions) {
    var count = transitions.length;
    var state = 0;
    for ( ; state < count; state++) {
      var found = false;
      var ranges = transitions[state];    
      while (true) {
        var right = ranges.length ~/ 2;
        if (right == 0) {
          break;
        }
        var left = 0;
        if (right == 1) {
          if (_ch <= ranges[1] && _ch >= ranges[0]) {
            found = true;          
          }
          break;
        }
        int middle;
        while (left < right) {
          middle = (left + right) >> 1;
          var index = middle << 1;
          if (ranges[index + 1] < _ch) {
            left = middle + 1;
          } else {
            if (_ch >= ranges[index]) {
              found = true;
              break;
            }
            right = middle;
          }
        }
        break;
      }
      if (found) {
        return state; 
      }   
    }
    if (_ch != -1) {
      return state;
    }
    return state + 1;  
  }
  
  List _list(Object first, List next) {
    var length = next.length;
    var list = new List(length + 1);
    list[0] = first;
    for (var i = 0; i < length; i++) {
      list[i + 1] = next[i][1];
    }
    return list;
  }
  
  String _matchAny() {
    success = _cursor < _inputLen;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }    
      if (++_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }    
      return result;
    }    
    return null;  
  }
  
  String _matchChar(int ch, String string) {
    success = _ch == ch;
    if (success) {
      var result = string;  
      if (++_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }    
      return result;
    }  
    return null;  
  }
  
  String _matchMapping(int start, int end, List<bool> mapping) {
    success = _ch >= start && _ch <= end;
    if (success) {    
      if(mapping[_ch - start]) {
        String result;
        if (_ch < 128) {
          result = _ascii[_ch];  
        } else {
          result = new String.fromCharCode(_ch);
        }     
        if (++_cursor < _inputLen) {
          _ch = _input[_cursor];
        } else {
          _ch = -1;
        }      
        return result;
      }
      success = false;
    }  
    return null;  
  }
  
  String _matchRange(int start, int end) {
    success = _ch >= start && _ch <= end;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }        
      if (++_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }  
      return result;
    }  
    return null;  
  }
  
  String _matchRanges(List<int> ranges) {
    var length = ranges.length;
    for (var i = 0; i < length; i += 2) {    
      if (_ch >= ranges[i]) {
        if (_ch <= ranges[i + 1]) {
          String result;
          if (_ch < 128) {
            result = _ascii[_ch];  
          } else {
            result = new String.fromCharCode(_ch);
          }          
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
             _ch = -1;
          }
          success = true;    
          return result;
        }      
      } else break;  
    }
    success = false;  
    return null;  
  }
  
  String _matchString(List<int> codePoints, String string) {
    var length = codePoints.length;  
    success = _cursor + length <= _inputLen;
    if (success) {
      for (var i = 0; i < length; i++) {
        if (codePoints[i] != _input[_cursor + i]) {
          success = false;
          break;
        }
      }
    } else {
      success = false;
    }  
    if (success) {
      _cursor += length;      
      if (_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }    
      return string;      
    }  
    return null; 
  }
  
  void _nextChar() {
    if (++_cursor < _inputLen) {
      _ch = _input[_cursor];
    } else {
      _ch = -1;
    }  
  }
  
  dynamic _parse_ACTION() {
    var $$;
    switch (_ch == 123 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '{';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            $$ = _parse_ACTION_BODY();
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(125, '}');
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            $$ = $2.join();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect5);
    }
    return $$;
  }
  
  dynamic _parse_ACTION_BODY() {
    var $$;
    _beginToken(1);  
    switch (_getState(_transitions8)) {
      case 0:
      case 3:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
          _testing = _inputLen + 1;
          $$ = _matchChar(125, '}');
          _ch = ch1;
          _cursor = pos1; 
          _testing = testing0;
          $$ = null;
          success = !success;
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _matchAny();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var ch2 = _ch, pos2 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = '{';
            success = true;
            if (++_cursor < _inputLen) {
              _ch = _input[_cursor];
            } else {
              _ch = -1;
            }
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            var testing1 = _testing; 
            for (var reps = []; ; ) {
              _testing = _cursor;
              $$ = _parse_ACTION_BODY();
              if (success) {  
                reps.add($$);
              } else {
                success = true;
                _testing = testing1;
                $$ = reps;
                break; 
              }
            }
            if (!success) break;
            seq[1] = $$;
            $$ = _matchChar(125, '}');
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos1;
          if (success) break;
          var ch3 = _ch, pos3 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch4 = _ch, pos4 = _cursor, testing2 = _testing; 
            _testing = _inputLen + 1;
            $$ = _matchChar(125, '}');
            _ch = ch4;
            _cursor = pos4; 
            _testing = testing2;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect23);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_AND() {
    var $$;
    switch (_ch == 38 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '&';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect6);
    }
    return $$;
  }
  
  dynamic _parse_CHAR() {
    var $$;
    _beginToken(2);  
    switch (_getState(_transitions9)) {
      case 0:
      case 3:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
          _testing = _inputLen + 1;
          $$ = _matchChar(92, '\\');
          _ch = ch1;
          _cursor = pos1; 
          _testing = testing0;
          $$ = null;
          success = !success;
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          var ch2 = _ch, pos2 = _cursor, testing1 = _testing; 
          _testing = _inputLen + 1;
          $$ = _parse_EOL();
          _ch = ch2;
          _cursor = pos2; 
          _testing = testing1;
          $$ = null;
          success = !success;
          if (!success) break;
          seq[1] = $$;
          $$ = _matchAny();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            $$ = _toCodePoint($3);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var ch3 = _ch, pos3 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = '\\';
            success = true;
            if (++_cursor < _inputLen) {
              _ch = _input[_cursor];
            } else {
              _ch = -1;
            }
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchMapping(34, 116, _mapping0);
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              $$ = _escape($2.codeUnitAt(0));
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          $$ = _parse_HEX_NUMBER();
          _startPos = startPos2;
          if (success) break;
          var ch4 = _ch, pos4 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch5 = _ch, pos5 = _cursor, testing2 = _testing; 
            _testing = _inputLen + 1;
            $$ = _matchChar(92, '\\');
            _ch = ch5;
            _cursor = pos5; 
            _testing = testing2;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            var ch6 = _ch, pos6 = _cursor, testing3 = _testing; 
            _testing = _inputLen + 1;
            $$ = _parse_EOL();
            _ch = ch6;
            _cursor = pos6; 
            _testing = testing3;
            $$ = null;
            success = !success;
            if (!success) break;
            seq[1] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              $$ = _toCodePoint($3);
            }
            break;
          }
          if (!success) {
            _ch = ch4;
            _cursor = pos4;
          }
          _startPos = startPos3;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect15);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_CLASS() {
    var $$;
    switch (_ch == 91 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '[';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  var ch2 = _ch, pos2 = _cursor, testing1 = _testing; 
                  _testing = _inputLen + 1;
                  $$ = _matchChar(93, ']');
                  _ch = ch2;
                  _cursor = pos2; 
                  _testing = testing1;
                  $$ = null;
                  success = !success;
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_RANGE();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  if (success) {    
                    final $1 = seq[0];
                    final $2 = seq[1];
                    $$ = $2;
                  }
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect8);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(93, ']');
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            $$ = new CharacterClassExpression($2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect7);
    }
    return $$;
  }
  
  dynamic _parse_CLOSE() {
    var $$;
    switch (_ch == 41 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = ')';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect9);
    }
    return $$;
  }
  
  dynamic _parse_COMMENT() {
    var $$;
    _beginToken(3);  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '#';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  var ch2 = _ch, pos2 = _cursor, testing1 = _testing; 
                  _testing = _inputLen + 1;
                  $$ = _parse_EOL();
                  _ch = ch2;
                  _cursor = pos2; 
                  _testing = testing1;
                  $$ = null;
                  success = !success;
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _matchAny();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect25);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          var testing2 = _testing;
          _testing = _cursor;
          $$ = _parse_EOL();
          success = true; 
          _testing = testing2;
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect24);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_DOT() {
    var $$;
    switch (_ch == 46 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '.';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect10);
    }
    return $$;
  }
  
  dynamic _parse_Definition() {
    var $$;
    switch (_getState(_transitions0)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_IDENTIFIER();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_LEFTARROW();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_Expression();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            $$ = new ProductionRule($1, $3);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    return $$;
  }
  
  dynamic _parse_EOF() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        var ch0 = _ch, pos0 = _cursor, testing0 = _testing; 
        _testing = _inputLen + 1;
        $$ = _matchAny();
        _ch = ch0;
        _cursor = pos0; 
        _testing = testing0;
        $$ = null;
        success = !success;
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect11);
    }
    return $$;
  }
  
  dynamic _parse_EOL() {
    var $$;
    _beginToken(4);  
    switch (_getState(_transitions10)) {
      case 0:
        var startPos0 = _startPos;
        $$ = _matchMapping(10, 13, _mapping1);
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var startPos1 = _startPos;
          $$ = _matchString(_strings3, '\r\n');
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          $$ = _matchMapping(10, 13, _mapping1);
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect26);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_Expression() {
    var $$;
    switch (_getState(_transitions1)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_Sequence();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch == 47 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_SLASH();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_Sequence();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
              case 2:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect2);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = new OrderedChoiceExpression(_list($1, $2));
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect1);
    }
    return $$;
  }
  
  dynamic _parse_GLOBALS() {
    var $$;
    switch (_ch == 37 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings0, '%{');
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            $$ = _parse_GLOBALS_BODY();
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _matchString(_strings1, '}%');
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            $$ = $2.join();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect12);
    }
    return $$;
  }
  
  dynamic _parse_GLOBALS_BODY() {
    var $$;
    _beginToken(5);  
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
          _testing = _inputLen + 1;
          $$ = _matchString(_strings1, '}%');
          _ch = ch1;
          _cursor = pos1; 
          _testing = testing0;
          $$ = null;
          success = !success;
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _matchAny();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect27);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_HEX_NUMBER() {
    var $$;
    _beginToken(6);  
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '\\';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _matchChar(117, 'u');
          if (!success) break;
          seq[1] = $$;
          var testing0;
          for (var first = true, reps; ;) {  
            $$ = _matchMapping(48, 102, _mapping2);  
            if (success) {
             if (first) {      
                first = false;
                reps = [$$];
                testing0 = _testing;                  
              } else {
                reps.add($$);
              }
              _testing = _cursor;   
            } else {
              success = !first;
              if (success) {      
                _testing = testing0;
                $$ = reps;      
              } else $$ = null;
              break;
            }  
          }
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            $$ = int.parse($3.join(), radix: 16);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect28);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_IDENTIFIER() {
    var $$;
    switch (_getState(_transitions0)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_IDENT_START();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            $$ = _parse_IDENT_CONT();
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            $$ = _flatten([$1, $2]).join();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    return $$;
  }
  
  dynamic _parse_IDENT_CONT() {
    var $$;
    _beginToken(7);  
    switch (_getState(_transitions11)) {
      case 0:
        var startPos0 = _startPos;
        $$ = _matchRange(48, 57);
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        $$ = _parse_IDENT_START();
        _startPos = startPos1;
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect29);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_IDENT_START() {
    var $$;
    _beginToken(8);  
    switch (_getState(_transitions0)) {
      case 0:
        var startPos0 = _startPos;
        $$ = _matchMapping(65, 122, _mapping3);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect30);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_LEFTARROW() {
    var $$;
    switch (_ch == 60 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings2, '<-');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect13);
    }
    return $$;
  }
  
  dynamic _parse_LITERAL() {
    var $$;
    switch (_getState(_transitions6)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '\"';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  var ch2 = _ch, pos2 = _cursor, testing1 = _testing; 
                  _testing = _inputLen + 1;
                  $$ = _matchChar(34, '\"');
                  _ch = ch2;
                  _cursor = pos2; 
                  _testing = testing1;
                  $$ = null;
                  success = !success;
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_CHAR();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  if (success) {    
                    final $1 = seq[0];
                    final $2 = seq[1];
                    $$ = $2;
                  }
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect15);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(34, '\"');
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            $$ = new LiteralExpression(new String.fromCharCodes($2));
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        var ch3 = _ch, pos3 = _cursor, startPos2 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '\'';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          var testing2 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch4 = _ch, pos4 = _cursor, startPos3 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  var ch5 = _ch, pos5 = _cursor, testing3 = _testing; 
                  _testing = _inputLen + 1;
                  $$ = _matchChar(39, '\'');
                  _ch = ch5;
                  _cursor = pos5; 
                  _testing = testing3;
                  $$ = null;
                  success = !success;
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_CHAR();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  if (success) {    
                    final $1 = seq[0];
                    final $2 = seq[1];
                    $$ = $2;
                  }
                  break;
                }
                if (!success) {
                  _ch = ch4;
                  _cursor = pos4;
                }
                _startPos = startPos3;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect15);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing2;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(39, '\'');
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            $$ = new LiteralExpression(new String.fromCharCodes($2));
          }
          break;
        }
        if (!success) {
          _ch = ch3;
          _cursor = pos3;
        }
        _startPos = startPos2;
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect14);
    }
    return $$;
  }
  
  dynamic _parse_MEMBERS() {
    var $$;
    switch (_ch == 123 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '{';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            $$ = _parse_ACTION_BODY();
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(125, '}');
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            $$ = $2.join();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect5);
    }
    return $$;
  }
  
  dynamic _parse_NOT() {
    var $$;
    switch (_ch == 33 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '!';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect16);
    }
    return $$;
  }
  
  dynamic _parse_OPEN() {
    var $$;
    switch (_ch == 40 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '(';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect17);
    }
    return $$;
  }
  
  dynamic _parse_PLUS() {
    var $$;
    switch (_ch == 43 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '+';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect18);
    }
    return $$;
  }
  
  dynamic _parse_Prefix() {
    var $$;
    switch (_getState(_transitions1)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var testing0 = _testing;
          _testing = _cursor;
          switch (_getState(_transitions2)) {
            case 0:
              var startPos1 = _startPos;
              $$ = _parse_NOT();
              _startPos = startPos1;
              break;
            case 1:
              var startPos2 = _startPos;
              $$ = _parse_AND();
              _startPos = startPos2;
              break;
            case 2:
            case 3:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(_expect3);
          }
          success = true; 
          _testing = testing0;
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_Suffix();
          if (!success) break;
          seq[1] = $$;
          var testing1 = _testing;
          _testing = _cursor;
          $$ = _parse_ACTION();
          success = true; 
          _testing = testing1;
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            $$ = _prefix($1, $2, $3);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect1);
    }
    return $$;
  }
  
  dynamic _parse_Primary() {
    var $$;
    switch (_getState(_transitions5)) {
      case 0:
        var startPos0 = _startPos;
        $$ = _parse_LITERAL();
        _startPos = startPos0;
        break;
      case 1:
        var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_OPEN();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_Expression();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_CLOSE();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            $$ = $2;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos1;
        break;
      case 2:
        var startPos2 = _startPos;
        $$ = _parse_DOT();
        if (success) {    
          final $1 = $$;
          $$ = new AnyCharacterExpression();
        }
        _startPos = startPos2;
        break;
      case 3:
        var ch1 = _ch, pos1 = _cursor, startPos3 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_IDENTIFIER();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var ch2 = _ch, pos2 = _cursor, testing0 = _testing; 
          _testing = _inputLen + 1;
          $$ = _parse_LEFTARROW();
          _ch = ch2;
          _cursor = pos2; 
          _testing = testing0;
          $$ = null;
          success = !success;
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = new RuleExpression($1);
          }
          break;
        }
        if (!success) {
          _ch = ch1;
          _cursor = pos1;
        }
        _startPos = startPos3;
        break;
      case 4:
        var startPos4 = _startPos;
        $$ = _parse_CLASS();
        _startPos = startPos4;
        break;
      case 5:
      case 6:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect1);
    }
    return $$;
  }
  
  dynamic _parse_QUESTION() {
    var $$;
    switch (_ch == 63 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '?';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect19);
    }
    return $$;
  }
  
  dynamic _parse_RANGE() {
    var $$;
    _beginToken(9);  
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_CHAR();
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _matchChar(45, '-');
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_CHAR();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              $$ = [$1, $3];
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          $$ = _parse_CHAR();
          if (success) {    
            final $1 = $$;
            $$ = [$1, $1];
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect8);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_SLASH() {
    var $$;
    switch (_ch == 47 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '/';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect2);
    }
    return $$;
  }
  
  dynamic _parse_SPACE() {
    var $$;
    _beginToken(10);  
    switch (_getState(_transitions12)) {
      case 0:
        var startPos0 = _startPos;
        $$ = _matchMapping(9, 32, _mapping4);
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        $$ = _parse_EOL();
        _startPos = startPos1;
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect31);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_SPACING() {
    var $$;
    _beginToken(0);  
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        var testing0 = _testing; 
        for (var reps = []; ; ) {
          _testing = _cursor;
          switch (_getState(_transitions7)) {
            case 0:
              var startPos1 = _startPos;
              $$ = _parse_SPACE();
              _startPos = startPos1;
              break;
            case 1:
              var startPos2 = _startPos;
              $$ = _parse_COMMENT();
              _startPos = startPos2;
              break;
            case 2:
            case 3:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(_expect21);
          }
          if (success) {  
            reps.add($$);
          } else {
            success = true;
            _testing = testing0;
            $$ = reps;
            break; 
          }
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = true;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect20);
    }
    _endToken();
    return $$;
  }
  
  dynamic _parse_STAR() {
    var $$;
    switch (_ch == 42 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = '*';
          success = true;
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
            _ch = -1;
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_SPACING();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect22);
    }
    return $$;
  }
  
  dynamic _parse_Sequence() {
    var $$;
    switch (_getState(_transitions1)) {
      case 0:
        var startPos0 = _startPos;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _parse_Prefix();  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        if (success) {    
          final $1 = $$;
          $$ = new SequenceExpression($1);
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect1);
    }
    return $$;
  }
  
  dynamic _parse_Suffix() {
    var $$;
    switch (_getState(_transitions3)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_Primary();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          switch (_getState(_transitions4)) {
            case 0:
              var startPos1 = _startPos;
              $$ = _parse_STAR();
              _startPos = startPos1;
              break;
            case 1:
              var startPos2 = _startPos;
              $$ = _parse_PLUS();
              _startPos = startPos2;
              break;
            case 2:
              var startPos3 = _startPos;
              $$ = _parse_QUESTION();
              _startPos = startPos3;
              break;
            case 3:
            case 4:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(_expect4);
          }
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            $$ = _suffix($2, $1);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect1);
    }
    return $$;
  }
  
  String _text() {
    return new String.fromCharCodes(_input.sublist(_startPos, _cursor));
  }
  
  int _toCodePoint(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      throw new StateError("An empty string contains no elements.");
    }
  
    var start = string.codeUnitAt(0);
    if (length == 1) {
      return start;
    }
  
    if ((start & 0xFC00) == 0xD800) {
      var end = string.codeUnitAt(1);
      if ((end & 0xFC00) == 0xDC00) {
        return (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
      }
    }
  
    return start;
  }
  
  List<int> _toCodePoints(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      return const <int>[];
    }
  
    var codePoints = <int>[];
    codePoints.length = length;
    var i = 0;
    var pos = 0;
    for ( ; i < length; pos++) {
      var start = string.codeUnitAt(i);
      i++;
      if ((start & 0xFC00) == 0xD800 && i < length) {
        var end = string.codeUnitAt(i);
        if ((end & 0xFC00) == 0xDC00) {
          codePoints[pos] = (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
          i++;
        } else {
          codePoints[pos] = start;
        }
      } else {
        codePoints[pos] = start;
      }
    }
  
    codePoints.length = pos;
    return codePoints;
  }
  
  static List<bool> _unmap(List<int> mapping) {
    var length = mapping.length;
    var result = new List<bool>(length * 31);
    var offset = 0;
    for (var i = 0; i < length; i++) {
      var v = mapping[i];
      for (var j = 0; j < 31; j++) {
        result[offset++] = v & (1 << j) == 0 ? false : true;
      }
    }
    return result;
  }
  
  List<PegParserError> errors() {
    if (success) {
      return <PegParserError>[];
    }
  
    String escape(int c) {
      switch (c) {
        case 10:
          return r"\n";
        case 13:
          return r"\r";
        case 09:
          return r"\t";
        case -1:
          return "";
      }
      return new String.fromCharCode(c);
    } 
    
    String getc(int position) {  
      if (position < _inputLen) {
        return "'${escape(_input[position])}'";      
      }       
      return "end of file";
    }
  
    var errors = <PegParserError>[];
    if (_failurePos >= _cursor) {
      var set = new Set<PegParserError>();
      set.addAll(_errors);
      for (var error in set) {
        if (error.position >= _failurePos) {
          errors.add(error);
        }
      }
      var names = new Set<String>();  
      names.addAll(_expected);
      if (names.contains(null)) {
        var string = getc(_failurePos);
        var message = "Unexpected $string";
        var error = new PegParserError(PegParserError.UNEXPECTED, _failurePos, _failurePos, message);
        errors.add(error);
      } else {      
        var found = getc(_failurePos);      
        var list = names.toList();
        list.sort();
        var message = "Expected ${list.join(", ")} but found $found";
        var error = new PegParserError(PegParserError.EXPECTED, _failurePos, _failurePos, message);
        errors.add(error);
      }        
    }
    errors.sort((a, b) => a.position.compareTo(b.position));
    return errors;  
  }
  
  dynamic parse_Grammar() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_SPACING();
          success = true; 
          _testing = testing0;
          if (!success) break;
          var seq = new List(5)..[0] = $$;
          var testing1 = _testing;
          _testing = _cursor;
          $$ = _parse_GLOBALS();
          success = true; 
          _testing = testing1;
          if (!success) break;
          seq[1] = $$;
          var testing2 = _testing;
          _testing = _cursor;
          $$ = _parse_MEMBERS();
          success = true; 
          _testing = testing2;
          if (!success) break;
          seq[2] = $$;
          var testing3;
          for (var first = true, reps; ;) {  
            $$ = _parse_Definition();  
            if (success) {
             if (first) {      
                first = false;
                reps = [$$];
                testing3 = _testing;                  
              } else {
                reps.add($$);
              }
              _testing = _cursor;   
            } else {
              success = !first;
              if (success) {      
                _testing = testing3;
                $$ = reps;      
              } else $$ = null;
              break;
            }  
          }
          if (!success) break;
          seq[3] = $$;
          $$ = _parse_EOF();
          if (!success) break;
          seq[4] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            final $5 = seq[4];
            $$ = new Grammar($4, $2, $3);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    return $$;
  }
  
  void reset(int pos) {
    if (pos == null) {
      throw new ArgumentError('pos: $pos');
    }
    if (pos < 0 || pos > _inputLen) {
      throw new RangeError('pos');
    }      
    _cursor = pos;
    _cache = new List(_inputLen + 1);
    _cachePos = -1;
    _cacheRule = new List(_inputLen + 1);
    _cacheState = new List.filled(((_inputLen + 1) >> 5) + 1, 0);
    _ch = -1;
    _errors = <PegParserError>[];   
    _expected = <String>[];
    _failurePos = -1;
    _startPos = pos;        
    _testing = -1;
    _token = null;
    _tokenLevel = 0;
    _tokenStart = null;
    if (_cursor < _inputLen) {
      _ch = _input[_cursor];
    }
    success = true;    
  }
  
}

class PegParserError {
  static const int EXPECTED = 1;    
      
  static const int MALFORMED = 2;    
      
  static const int MISSING = 3;    
      
  static const int UNEXPECTED = 4;    
      
  static const int UNTERMINATED = 5;    
      
  final int hashCode = 0;
  
  final String message;
  
  final int position;
  
  final int start;
  
  final int type;
  
  PegParserError(this.type, this.position, this.start, this.message);
  
  bool operator ==(other) {
    if (identical(this, other)) return true;
    if (other is PegParserError) {
      return type == other.type && position == other.position &&
      start == other.start && message == other.message;  
    }
    return false;
  }
  
}

